<?php

class ACMS_GET_Admin_Form_Log extends ACMS_GET_Admin_Module
{
    function get()
    {
        if ( 'form_log' <> ADMIN ) return '';
        if ( !sessionWithAdministration() ) return '';
        if ( !($fmid = intval($this->Get->get('fmid'))) ) return false;

        $Tpl    = new Template($this->tpl, new ACMS_Corrector());
        $Vars   = array();

        //---------
        // refresh
        if ( !$this->Post->isNull() ) $Tpl->add('refresh');

        //-------
        // order
        $order  = ORDER ? ORDER : 'datetime-desc';
        $Vars['order:selected#'.$order] = config('attr_selected');

        //--------
        // limit
        $limits = configArray('admin_limit_option');
        $limit  = $this->Q->get('limit', $limits[config('admin_limit_default')]);
        foreach ( $limits as $val ) {
            $_vars  = array('value' => $val);
            if ( $limit == $val ) $_vars['selected'] = config('attr_selected');
            $Tpl->add('limit:loop', $_vars);
        }

        //-------
        // span
        $Vars   += array(
            'start' => START,
            'end'   => END,
        );

        $DB     = DB::singleton(dsn());
        $SQL    = SQL::newSelect('log_form');
        $SQL->addWhereOpr('log_form_form_id', $fmid);
        $SQL->addWhereOpr('log_form_blog_id', BID);
        $SQL->addWhereBw('log_form_datetime', START, END);

        if ( $this->Get->isExists('serial') ) {
            $SQL->addWhereOpr('log_form_serial', $this->Get->get('serial'));
        }

        $Amount = new SQL_Select($SQL);
        $Amount->setSelect('*', 'form_amount', null, 'count');

        if ( !$pageAmount = $DB->query($Amount->get(dsn()), 'one') ) {
            $Tpl->add('index#notFound');
            $Tpl->add(null, $Vars);
            return $Tpl->get();
        }
        $Vars   += $this->buildPager(PAGE, $limit, $pageAmount
            , config('admin_pager_delta'), config('admin_pager_cur_attr'), $Tpl, array(), array('admin' => ADMIN)
        );

        list($fd, $sort) = explode('-', $order);
        $SQL->setOrder('log_form_'.$fd, strtoupper($sort));
        $SQL->setLimit($limit, (PAGE - 1) * $limit);

        $q  = $SQL->get(dsn());
        $DB->query($q, 'fetch');
        while ( $row = $DB->fetch($q) ) {
            $Tpl->add('log:loop', array(
                'bid'           => $row['log_form_blog_id'],
                'fmid'          => $fmid,
                'serial'        => $row['log_form_serial'],
                'datetime'      => $row['log_form_datetime'],
                'mail_to'       => $row['log_form_mail_to'],
                'mail_subject'  => $row['log_form_mail_subject'],
                'mail_body'     => $row['log_form_mail_body'],
            ));
        }

        $DB     = DB::singleton(dsn());
        $SQL    = SQL::newSelect('form');
        $SQL->setSelect('form_name');
        $SQL->addWhereOpr('form_id', $fmid);
        $SQL->addWhereOpr('form_blog_id', BID);
        $Vars['formName']   = $DB->query($SQL->get(dsn()), 'one');

        $Tpl->add(null, $Vars);
        return $Tpl->get();
    }
}
